You are given coins of different denominations and a total amount of money. Write a function to compute the number of combinations that make up that amount. You may assume that you have infinite number of each kind of coin.
Example 1:
Input: amount = 5, coins = [1, 2, 5] Output: 4 Explanation: there are four ways to make up the amount: 5=5 5=2+2+1 5=2+1+1+1 5=1+1+1+1+1
Example 2:
Input: amount = 3, coins = [2] Output: 0 Explanation: the amount of 3 cannot be made up just with coins of 2.
Example 3:
Input: amount = 10, coins = [10] Output: 1
Note:
You can assume that
- 0 <= amount <= 5000
- 1 <= coin <= 5000
- the number of coins is less than 500
- the answer is guaranteed to fit into signed 32-bit integer
给定一堆不同面值的硬币,问凑齐amount块钱,有多少种不同的凑齐方案。
与LeetCode Coin Change类似,也用动态规划。假设dp[i][j]表示用前i类硬币,凑齐j块钱的方案数。则有两种情况,一是不用第i类硬币,有dp[i-1][j]种情况;二是用第i类硬币,则还需要凑齐j-coins[i]块钱,因为每类硬币无穷个,所以还是用前i类硬币凑齐j-coins[i]块钱,即有dp[i][j-coins[i]]种情况。两种情况数相加即可。完整代码如下:
class Solution {
public:
int change(int amount, vector<int>& coins) {
if(amount == 0) return 1;
int n = coins.size();
vector<vector<int>> dp(n + 1, vector<int>(amount + 1, 0));
for(int i = 0; i <= n; ++i) dp[i][0] = 1;
for(int i = 1; i <= n; ++i) {
for(int j = 1; j <= amount; ++j) {
dp[i][j] = dp[i - 1][j];
if(j >= coins[i - 1]) dp[i][j] += dp[i][j - coins[i - 1]];
}
}
return dp[n][amount];
}
};
本代码提交AC,用时60MS。